C. Divide by Three - Educational Codeforces Round 18

https://codeforces.com/contest/792/problem/C

题目大意

用字符串给出一个十进制大整数 $S \ (|S| \le 10^5)$。问最少删掉多少位可以得到一个没有前导零的能被 $3$ 整除的数。输出这个数。

简要题解

允许前导零的话这题非常水,直接 $dp[i][j]$ 表示到第 $i$ 位 $\mod 3$ 为 $j$ 的最多选数数量即可。

不允许前导零,相当于两种情况:

  1. 只有一个 $0$
  2. 总是以某个非零数字开始

因此反着进行 dp,算对答案贡献的时候把第一位特判就可以了。

特别注意,不能直接使用 $dp[i][0]$ 的值,需要特判第一位,因为 $dp[i][0]$ 的值可能是转移自不选当前位的情况!

一组数据

20000111

错误的代码实现

void solve() {
  string s; cin >> s;
  int n = s.length();

  vector<vector<int>> dp(3, vector<int>(n + 1, -1));
  dp[0][n] = 0;
  int mx = 0, p = -1; 
  for (int i = n - 1; i >= 0; i--) {
    int v = (s[i] - '0');
    for (int pre = 0; pre < 3; pre++) {
      if (dp[pre][i + 1] == -1) continue;

      cmax(dp[pre][i], dp[pre][i + 1]);
      cmax(dp[(pre + v) % 3][i], dp[pre][i + 1] + 1);
    }

    if (v) {
      int pre = (9 - (s[i] - '0')) % 3;
      if (dp[0][i] != -1 && dp[0][i] == dp[pre][i + 1] + 1) {
        if (ckmax(mx, dp[0][i])) {
          p = i;
        }
      }
    } else {
      if (!mx) {
        mx = 1;
        p = i;
      }
    }

    for (int cur = 0; cur < 3; cur++) {
      cerr << dp[cur][i] << ' ';
    }
    cerr << '\n';
    cerr << mx << ' ' << p << endl;
  }

  if (mx == 0) {
    cout << "-1\n";
    return;
  }

  int lft = 0;
  for (int i = p; i < n; i++) {
    if (dp[lft][i] == dp[lft][i + 1]) continue;
    lft = (lft + 9 - (s[i] - '0')) % 3;
    cout << s[i];
  }
  cout << '\n';
}

复杂度

$T$:$O(n)$

$S$:$O(n)$

代码实现

#include <bits/stdc++.h>
using namespace std;

int io_=[](){ ios::sync_with_stdio(false); cin.tie(nullptr); return 0; }();

using LL = long long;
using ULL = unsigned long long;
using LD = long double;
using PII = pair<int, int>;
using VI = vector<int>;
using MII = map<int, int>;

template<typename T> void cmin(T &x,const T &y) { if(y<x) x=y; }
template<typename T> void cmax(T &x,const T &y) { if(x<y) x=y; }
template<typename T> bool ckmin(T &x,const T &y) { 
    return y<x ? (x=y, true) : false; }
template<typename T> bool ckmax(T &x,const T &y) { 
    return x<y ? (x=y, true) : false; }
template<typename T> void cmin(T &x,T &y,const T &z) {// x<=y<=z 
    if(z<x) { y=x; x=z; } else if(z<y) y=z; }
template<typename T> void cmax(T &x,T &y,const T &z) {// x>=y>=z
    if(x<z) { y=x; x=z; } else if(y<z) y=z; }

// mt19937 rnd(chrono::system_clock::now().time_since_epoch().count());
// mt19937_64 rnd_64(chrono::system_clock::now().time_since_epoch().count());

/*
---------1---------2---------3---------4---------5---------6---------7---------
1234567890123456789012345678901234567890123456789012345678901234567890123456789
*/

const int INF = 0x3f3f3f3f;

void solve() {
  string s; cin >> s;
  int n = s.length();

  vector<vector<int>> dp(3, vector<int>(n + 1, -1));
  dp[0][n] = 0;
  int mx = 0, p = -1; 
  bool has0 = false;
  for (int i = n - 1; i >= 0; i--) {
    int v = (s[i] - '0');
    for (int pre = 0; pre < 3; pre++) {
      if (dp[pre][i + 1] == -1) continue;

      cmax(dp[pre][i], dp[pre][i + 1]);
      cmax(dp[(pre + v) % 3][i], dp[pre][i + 1] + 1);
    }

    if (v) {
      int pre = (9 - (s[i] - '0')) % 3;
      if (dp[pre][i + 1] != -1 && ckmax(mx, dp[pre][i + 1] + 1)) {
        p = i;
      }
    } else {
      has0 = true;
    }

    // for (int cur = 0; cur < 3; cur++) {
    //   cerr << dp[cur][i] << ' ';
    // }
    // cerr << '\n';
    // cerr << mx << ' ' << p << endl;
  }

  if (mx == 0) {
    if (has0) {
      cout << "0\n";
    } else {
      cout << "-1\n";
    }
    return;
  }

  int lft = 0;
  for (int i = p; i < n; i++) {
    int nlft = (lft + 9 - (s[i] - '0')) % 3;
    if (dp[nlft][i + 1] != -1 && mx == dp[nlft][i + 1] + 1) {
      cout << s[i];
      mx--;
      lft = nlft;
    }
  }
  cout << '\n';
}

int main() {
  int t = 1; 
  // cin >> t;
  while (t--) {
    solve();
  }
  return 0;
}
Prev: D. Paths in a Complete Binary Tree - Educational Codeforces Round 18
Next: B. Counting-out Rhyme - Educational Codeforces Round 18